﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>
#include <queue>
#include <map>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using str = string;

ll gcd(ll a, ll b) {
    if (b > a) swap(a, b);
    if (b == 0) return a;
    return gcd(b, a % b);
}


map<ll, vll> g;

void bfs(ll v,ll n) {
    queue<ll> stack;
    vll used(n + 1);
    stack.push(v);
    used[v] = 1;
    while (!stack.empty()) {
        ll ver = stack.front();
        cout << ver << endl;
        stack.pop();
        for (auto i : g[ver]) {
            if (used[i] == 0) {
                stack.push(i);
                used[i] = 1;
            }
        }
    }
}

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fast();
    ll n;
    cin >> n;
    map<ll, ll> dots;
    vector <pair<ll, ll>> no;
    vector<vll> an;
    while (n--) {
        ll t;
        cin >> t;
        if (t == 0) {
            ll m, n;
            cin >> m >> n;
            dots[m] = n;
        }
        if (t == 1) {
            ll x, y;
            cin >> x >> y;
            no.push_back({ x,y });
        }
        if (t == 2) {
            ll x, y, z;
            cin >> x >> y >> z;
            an.push_back({ x,y,z });
        }
        if (t == 3) {
            ll k, time;
            cin >> k >> time;
            while (time--) {
                map<ll, ll> ndots;
                for (auto para: no) {
                    ndots[para.second] = !dots[para.first];
                }
                for (auto data : an) {
                    if (dots[data[0]] == 1 && dots[data[1]] == 1) ndots[data[2]] = 1;
                    else ndots[data[2]] = 0;
                }
                cout << ndots[k] << endl;
                for (auto para : ndots) {
                    dots[para.first] = para.second;
                }
            }
        }
    }
}

